Loading...
Searching...
No Matches
object_interface_type.h File Reference

ObjectInterfaceType enum. More...

`#include <cstddef>`
`#include <array>`
Include dependency graph for object_interface_type.h:

## Typedefs

using | ObjectInterfaceTypes = std::array<bool, static_cast<std::size_t>(ObjectInterfaceType::Max)>

## Enumerations

enum class | ObjectInterfaceType { Interactive , Transportable , ProgramStorage , Programmable , TaskExecutor , Jostleable , Movable , Flying , JetFlying , Controllable , PowerContainer , Ranged , TraceDrawing , Damageable , Destroyable , Fragile , Shielded , ShieldedAutoRegen , Old , Slotted , Max }
| Type of interface that an object implements. More...

## Detailed Description

ObjectInterfaceType enum.

## Enumeration Type Documentation

## ObjectInterfaceType

enum class ObjectInterfaceType

strong

Type of interface that an object implements.

Enumerator
Interactive | interactive objects can process events from event loop
Transportable | objects that can be carried by robots or astronaut
ProgramStorage | objects that store CBOT programs
Programmable | objects that can be programmed in CBOT
TaskExecutor | objects that can execute tasks (CTask classes)
Jostleable | object that can be jostled
Movable | objects that can move
Flying | objects that can fly
JetFlying | objects that can fly using a jet engine
Controllable | objects that can be selected and controlled by the player
PowerContainer | objects that hold power
Ranged | objects that have a operation range to be displayed after pressing button in the UI
TraceDrawing | objects that can draw wheel trace
Damageable | objects that generate particles when hit
Destroyable | objects that can be destroyed (base for Shielded and Fragile)
Fragile | objects that are destroyed immediately after hit
Shielded | objects that can be destroyed after the shield goes down to 0
ShieldedAutoRegen | shielded objects with auto shield regeneration
Old | old objects, TODO: remove once no longer necessary
Slotted | objects that can carry other objects (in their gripper, power cell slot, or other slots)
Max | maximum value (for getting number of items in enum)